VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Pencil"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim oldpenciltilex As Integer
Dim oldpenciltiley As Integer
Dim parent As frmMain

Dim undoch As Changes

Sub setParent(main As frmMain)
    Set parent = main
End Sub

Sub MouseDown(Button As Integer, x As Single, y As Single)
Dim curtilex As Integer
Dim curtiley As Integer
curtilex = (Int(((parent.hScr.value + x)) / (TileW * parent.magnifier.Zoom)))
curtiley = (Int(((parent.vscr.value + y)) / (TileH * parent.magnifier.Zoom)))
If (curtilex < 0 Or curtiley < 0 Or curtilex > 1023 Or curtiley > 1023) Then
    Exit Sub
End If

    
    parent.undoredo.ResetRedo
    Set undoch = New Changes
    
    oldpenciltilex = curtilex
    oldpenciltiley = curtiley
    
    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer
    
    If curtool = T_Eraser Then
        tmptile = 0
        tmpTileSizeX = 1
        tmpTileSizeY = 1
    Else
        If Button = vbLeftButton Then
            tmptile = parent.tilesetleft
            tmpTileSizeX = parent.multTileLeftx
            tmpTileSizeY = parent.multTileLefty
        Else
            tmptile = parent.tilesetright
            tmpTileSizeX = parent.multTileRightx
            tmpTileSizeY = parent.multTileRighty
        End If
    End If
    
    If tmptile = 217 Or tmptile = 219 Or _
       tmptile = 220 Then
        Call setObject(parent, tmptile, curtilex, curtiley, undoch)
    Else
        If isTileSpecial(parent, curtilex, curtiley) Then
            Call SearchAndDestroyObject(parent, curtilex, curtiley, undoch)
        End If
        
        Dim i As Integer
        Dim j As Integer
    If tmpTileSizeX > 1 Or tmpTileSizeY > 1 Then
        Call MouseMove(Button, x, y)
    Else
        If parent.tline.linew <> 1 Then
            For j = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                For i = -Int(parent.tline.linew / 2) + 1 To Int(parent.tline.linew / 2)
                    If parent.pastetype <> p_under Or _
                       parent.pastetype = p_under And parent.getTile(curtilex + i, curtiley + j) = 0 Then
                        If curtilex + i >= 0 And curtilex + i <= 1023 And curtiley + j >= 0 And curtiley + j <= 1023 Then
                            Call parent.setTile(curtilex + i, curtiley + j, tmptile, undoch)
                            Call parent.UpdateLevelTile(curtilex + i, curtiley + j, False)
                        End If
                    End If
                Next
            Next
        Else
            If parent.pastetype <> p_under Or _
               parent.pastetype = p_under And parent.getTile(curtilex + i, curtiley + j) = 0 Then
                Call parent.setTile(curtilex, curtiley, tmptile, undoch)
                Call parent.UpdateLevelTile(curtilex, curtiley, False)
            End If
        End If
    End If
    
        If parent.magnifier.UsingPixels Then
            parent.UpdateLevel
        Else
            parent.UpdatePreview
        End If
    End If
    parent.mapchanged = True
End Sub

Sub MouseMove(Button As Integer, x As Single, y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer
        
    curtilex = (Int(((parent.hScr.value + x)) / (TileW * parent.magnifier.Zoom)))
    curtiley = (Int(((parent.vscr.value + y)) / (TileH * parent.magnifier.Zoom)))
    
    If curtilex < 0 Then curtilex = 0
    If curtiley < 0 Then curtiley = 0
    If curtilex > 1023 Then curtilex = 1023
    If curtiley > 1023 Then curtiley = 1023
    
    Dim tmptile As Integer
    Dim tmpTileSizeX As Integer
    Dim tmpTileSizeY As Integer
    
    If curtool = T_Eraser Then
        tmptile = 0
        tmpTileSizeX = 1
        tmpTileSizeY = 1
    Else
        If Button = vbLeftButton Then
            tmptile = parent.tilesetleft
            tmpTileSizeX = parent.multTileLeftx
            tmpTileSizeY = parent.multTileLefty
        Else
            tmptile = parent.tilesetright
            tmpTileSizeX = parent.multTileRightx
            tmpTileSizeY = parent.multTileRighty
        End If
    End If


    If curtool = t_spline Or SharedVar.MouseDown Then
         If tmptile = 217 Or tmptile = 219 Or _
            tmptile = 220 Then
             'Call setObject(parent, tmptile, curtilex, curtiley, undoch)
             'Don't draw special objects on mousemove
             Exit Sub
         Else
            'draw a line from the old x,y s
            'its more fluent
            If oldpenciltilex >= 0 And oldpenciltilex < 1024 And _
               oldpenciltiley >= 0 And oldpenciltiley < 1024 Then
                Call parent.tline.DrawLine(tmptile, oldpenciltilex, oldpenciltiley, curtilex, curtiley, undoch, tmpTileSizeX, tmpTileSizeY, False, False)
            End If
         End If
         
        If parent.magnifier.UsingPixels Then
            parent.UpdateLevel
        Else
            parent.UpdatePreview
        End If
    End If
     
     oldpenciltilex = curtilex
     oldpenciltiley = curtiley
End Sub

Sub MouseUp()
    'do nothing
    Call parent.undoredo.AddToUndo(undoch)
    'for tile 0 being gridded again we need to update the level
    Call parent.UpdateLevel
    
End Sub
