Attribute VB_Name = "TileStuff"
Option Explicit

Function TilePixelColor(tileval As Integer) As Long
    Select Case tileval
    Case 0 'empty
      TilePixelColor = vbBlack
    Case -1 ' special case, for bigger special tiles
      TilePixelColor = RGB(255, 255, 0)
    Case 1 To 161 'normal
      TilePixelColor = RGB(192, 192, 192)
    Case 162 To 165 'Vdoor
      TilePixelColor = vbBlue 'RGB(255, 0, 255)
    Case 166 To 169 'Hdoor
      TilePixelColor = vbBlue 'RGB(255, 0, 255)
    Case 170 'flag
      TilePixelColor = vbYellow
    Case 171 'safe
      TilePixelColor = vbGreen
    Case 172 'soccer
      TilePixelColor = vbRed
    Case 173 To 175 'flyover
      TilePixelColor = vbCyan
    Case 176 To 183 'flyunderopaque
      TilePixelColor = vbCyan
    Case 184 To 190 'flyundertransparent
      TilePixelColor = vbCyan
    Case 216 'sasteroid1
      TilePixelColor = vbWhite
    Case 217 'lasteroid
      TilePixelColor = vbWhite
    Case 218 'sasteroid2
      TilePixelColor = vbWhite
    Case 219 'starport
      TilePixelColor = vbWhite
    Case 220 'wormhole
      TilePixelColor = vbWhite
    Case 221 To 255
      TilePixelColor = vbMagenta
    Case Else 'invalid
      TilePixelColor = vbBlack
  End Select
End Function

Function isTileSpecial(x As Integer, y As Integer)
    If Not (x < 0 Or y < 0 Or x > 1023 Or y > 1023) Then
        If tile(x, y) <> 217 And tile(x, y) <> 219 And _
           tile(x, y) <> 220 And tile(x, y) <> -1 Then
            isTileSpecial = False
        Else
            isTileSpecial = True
        End If
    End If
End Function


